/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/*
 * Copyright 2009 Lukasz Wozniak
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */
package com.sos.VirtualFileSystem.CredentialStore.KeePass.pl.sind.keepass.kdb.v1;
import java.nio.ByteBuffer;

import org.apache.log4j.Logger;

public class HeaderV1 {
	@SuppressWarnings("unused") private final String		conClassName	= this.getClass().getSimpleName();
	@SuppressWarnings("unused") private static final String	conSVNVersion	= "$Id$";
	@SuppressWarnings("unused") private final Logger		logger			= Logger.getLogger(this.getClass());
	public static int										LENGTH			= 124;
	int														dwSignature1;
	int														dwSignature2;
	int														dwFlags;
	int														dwVersion;
	byte[]													aMasterSeed;
	byte[]													aEncryptionIV;
	int														dwGroups;
	int														dwEntries;
	byte[]													aContentsHash;
	byte[]													aMasterSeed2;
	int														dwKeyEncRounds;

	public HeaderV1(final ByteBuffer bb) {
		bb.rewind();
		dwSignature1 = bb.getInt();
		dwSignature2 = bb.getInt();
		dwFlags = bb.getInt();
		dwVersion = bb.getInt();
		bb.get(aMasterSeed = new byte[16]);
		bb.get(aEncryptionIV = new byte[16]);
		dwGroups = bb.getInt();
		dwEntries = bb.getInt();
		bb.get(aContentsHash = new byte[32]);
		bb.get(aMasterSeed2 = new byte[32]);
		dwKeyEncRounds = bb.getInt();
	}

	public int getSignature1() {
		return dwSignature1;
	}

	public int getSignature2() {
		return dwSignature2;
	}

	public int getFlags() {
		return dwFlags;
	}

	public int getVersion() {
		return dwVersion;
	}

	public byte[] getMasterSeed() {
		return aMasterSeed;
	}

	public byte[] getEncryptionIV() {
		return aEncryptionIV;
	}

	public int getGroups() {
		return dwGroups;
	}

	public int getEntries() {
		return dwEntries;
	}

	public byte[] getContentsHash() {
		return aContentsHash;
	}

	public byte[] getMasterSeed2() {
		return aMasterSeed2;
	}

	public int getKeyEncRounds() {
		return dwKeyEncRounds;
	}

	@Override public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append('{');
		sb.append("dwVersion=").append(Integer.toHexString(dwVersion));
		sb.append(", ");
		sb.append("dwGroups=").append(dwGroups);
		sb.append(", ");
		sb.append("dwEntries=").append(dwEntries);
		sb.append(", ");
		sb.append("dwKeyEncRounds=").append(dwKeyEncRounds);
		sb.append('}');
		return sb.toString();
	}
}
