/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/**
 *
 */
package com.sos.VirtualFileSystem.TCPIP;
// TCPServer.java
// A server program implementing TCP socket
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.FileWriter;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * @author KB
 *
 */
public class SOSVfsTcpIpServer {
	/**
	 *
	 */
	public SOSVfsTcpIpServer() {
	}

	public static void main(final String args[]) {
		ServerSocket listenSocket = null;
		try {
			int serverPort = 6880;
			listenSocket = new ServerSocket(serverPort);
			System.out.println("server start listening... ... ...");
			while (true) {
				Socket clientSocket = listenSocket.accept();
				Connection c = new Connection(clientSocket);
			}
		}
		catch (IOException e) {
			System.out.println("Listen :" + e.getMessage());
		}
		finally {
			try {
				listenSocket.close();
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}

class Connection extends Thread {
	DataInputStream		input;
	DataOutputStream	output;
	Socket				clientSocket;

	public Connection(final Socket aClientSocket) {
		try {
			clientSocket = aClientSocket;
			input = new DataInputStream(clientSocket.getInputStream());
			output = new DataOutputStream(clientSocket.getOutputStream());
			this.start();
		}
		catch (IOException e) {
			System.out.println("Connection:" + e.getMessage());
		}
	}

	@Override
	public void run() {
		try { // an echo server
			//  String data = input.readUTF();
			FileWriter out = new FileWriter("test.txt");
			BufferedWriter bufWriter = new BufferedWriter(out);
			//Step 1 read length
			int nb = input.readInt();
			System.out.println("Read Length" + nb);
			byte[] digit = new byte[nb];
			//Step 2 read byte
			System.out.println("Writing.......");
			for (int i = 0; i < nb; i++)
				digit[i] = input.readByte();
			String st = new String(digit);
			bufWriter.append(st);
			bufWriter.close();
			System.out.println("receive from : " + clientSocket.getInetAddress() + ":" + clientSocket.getPort() + " message - " + st);
			//Step 1 send length
			output.writeInt(st.length());
			//Step 2 send length
			output.writeBytes(st); // UTF is a string encoding
			//  output.writeUTF(data);
		}
		catch (EOFException e) {
			System.out.println("EOF:" + e.getMessage());
		}
		catch (IOException e) {
			System.out.println("IO:" + e.getMessage());
		}
		finally {
			try {
				clientSocket.close();
			}
			catch (IOException e) {/*close failed*/
			}
		}
	}

	@SuppressWarnings("unused")
	private String readUntil0 (final DataInputStream readSock) throws IOException {
		   byte[] input1 = new byte[64];
		   int k = -1;
		   do {
			   k++;
			   input1 [k] = readSock.readByte();
			}  while(input1[k] != 0);
			k--;
			byte[] toConvert = new byte[k];
			for(int i = 0; i < k; i++)
			   toConvert[i] = input1[i];
			return new String(toConvert);
		}

}
