/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dialog;
import org.apache.log4j.Logger;
import org.eclipse.jface.resource.ColorRegistry;
import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;

import com.sos.dialog.classes.SOSMsgControl;

public class Globals {
	private final static Logger	logger			= Logger.getLogger(Globals.class);
	public final String			conSVNVersion	= "$Id: Globals.java 23878 2014-04-22 18:02:41Z kb $";
	//	public static int gTextBoxStyle = SWT.None;
	public static int			gTextBoxStyle	= SWT.BORDER;
	public static int			gButtonStyle	= SWT.BORDER;
	public static FontRegistry	stFontRegistry	= new FontRegistry();
	public static ColorRegistry	stColorRegistry	= new ColorRegistry();
	public static SOSMsgControl	MsgHandler		= null;

	public Globals() {
	}
	public static ApplicationWindow	Application	= null;

	public static void setApplicationWindow(final ApplicationWindow pobjAW) {
		Application = pobjAW;
	}

	public static void setStatus(final String pobjMessage) {
		Application.setStatus(pobjMessage);
	}

	public static Color getWidgetBackground() {
		return Application.getShell().getDisplay().getSystemColor(SWT.COLOR_WIDGET_BACKGROUND);
	}

	public static Color getCompositeBackground() {
		Color objC = stColorRegistry.get("CompositeBackGround");
		if (objC == null && Application != null) {
			objC = Application.getShell().getDisplay().getSystemColor(SWT.COLOR_WIDGET_BACKGROUND);
		}
		return objC;
	}

	public static Color getFieldBackground() {
		Color objC = stColorRegistry.get("FieldBackGround");
		if (objC == null) {
			objC = Application.getShell().getDisplay().getSystemColor(SWT.COLOR_WIDGET_BACKGROUND);
		}
		return objC;
	}

	public static Color getFieldHasFocusBackground() {
		Color objC = stColorRegistry.get("Color4FieldHasFocus");
		if (objC == null) {
			objC = Application.getShell().getDisplay().getSystemColor(SWT.COLOR_WIDGET_BACKGROUND);
		}
		return objC;
	}

	public static String stateMask(final int stateMask) {
		String string = "[";
		if ((stateMask & SWT.CTRL) != 0)
			string += " CTRL";
		if ((stateMask & SWT.ALT) != 0)
			string += " ALT";
		if ((stateMask & SWT.SHIFT) != 0)
			string += " SHIFT";
		if ((stateMask & SWT.COMMAND) != 0)
			string += " COMMAND";
		if ((stateMask & SWT.BUTTON1) != 0)
			string += " BUTTON1";
		if ((stateMask & SWT.BUTTON2) != 0)
			string += " BUTTON2";
		if ((stateMask & SWT.BUTTON3) != 0)
			string += " BUTTON3";
		if ((stateMask & SWT.BUTTON4) != 0)
			string += " BUTTON4";
		if ((stateMask & SWT.BUTTON5) != 0)
			string += " BUTTON5";
		return string + "], ";
	}
	public static Listener	listener	= new Listener() {
											@Override public void handleEvent(final Event e) {
												String string = "Unknown";
												switch (e.type) {
													case SWT.MouseDoubleClick:
														string = "DOUBLE-CLICK";
														break;
													case SWT.MouseDown:
														string = "DOWN";
														break;
													case SWT.MouseMove:
														string = "MOVE";
														break;
													case SWT.MouseUp:
														string = "UP";
														break;
													case SWT.MouseEnter:
														string = "ENTER";
														break;
													case SWT.MouseExit:
														string = "EXIT";
														break;
													case SWT.MouseVerticalWheel:
														string = "WHEEL VERTICAL";
														break;
													case SWT.MouseHorizontalWheel:
														string = "WHEEL HORIZONTAL";
														break;
												}
												string += " - button=" + e.button + ", ";
												string += "stateMask=0x" + Integer.toHexString(e.stateMask) + stateMask(e.stateMask);
												string += "location=(" + e.x + ", " + e.y + "), ";
												if (e.type == SWT.MouseVerticalWheel) {
													string += "detail=";
													string += e.detail == SWT.SCROLL_PAGE ? "SCROLL_PAGE, " : "SCROLL_LINE, ";
												}
												string += "count=" + e.count + ", widget=" + e.widget;
												logger.trace(string);
											}
										};
}
