/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dialog.auth; 

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

 
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
 
public class SOSLoginForm extends Composite {

    /**
     * Create the composite.
     * @param parent
     * @param style
     */
    private Button           btnOk;
    private Button           btnCancel;
    private Label lblUser;
    private Label lblPassword;
    private Text user;
    private Text password;
    private Label lbMessage;
 
    public SOSLoginForm(Composite parent, int style ) {
        super(parent, style);
        setLayout(new GridLayout(2, false));
        createContent();
    }

    private void createContent() {
        
        lblUser = new Label(this, SWT.NONE);
        lblUser.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
        lblUser.setText("User");
        
        user = new Text(this, SWT.BORDER);
        user.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        
        lblPassword = new Label(this, SWT.NONE);
        lblPassword.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
        lblPassword.setText("Password");
        
        password = new Text(this, SWT.BORDER);
        password.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
 
        btnOk = new Button(this, SWT.NONE);

        GridData gd_btnOk = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
        gd_btnOk.widthHint = 91;
        gd_btnOk.minimumWidth = 100;
        btnOk.setLayoutData(gd_btnOk);
        btnOk.setText("Ok");

        btnCancel = new Button(this, SWT.NONE);
        GridData gd_btnCancel = new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1);
        gd_btnCancel.minimumWidth = 100;
        gd_btnCancel.widthHint = 101;
        btnCancel.setLayoutData(gd_btnCancel);
        btnCancel.setText("Cancel");
        
        lbMessage = new Label(this, SWT.NONE);
        GridData gd_lbMessage = new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1);
        gd_lbMessage.widthHint = 262;
        lbMessage.setLayoutData(gd_lbMessage);
        lbMessage.setText("Login das ist das Haus vom Nikolaus");
        new Label(this, SWT.NONE);
        new Label(this, SWT.NONE);
    }

    @Override
    protected void checkSubclass() {
        // Disable the check that prevents subclassing of SWT components
    }

    public Button getBtnOk() {
        return btnOk;
    }


    public Button getBtnCancel() {
        return btnCancel;
    }

    public Text getUser() {
        return user;
    }

    public Text getPassword() {
        return password;
    }

//    public Button getBtnRememberMe() {
       // return btnRememberMe;
//    }

    public void setMsg(String msg) {
        lbMessage.setText(msg);
    }
 

}
