/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dialog.components;

import java.util.prefs.Preferences;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

 
 
public class SOSMenuItem extends MenuItem {
    private static final String SOS_SCHEDULER = "SOS_SCHEDULER";

     private Preferences prefs;
     private String menuName="";

    public SOSMenuItem(Menu parent, int style, String label) {
        super(parent, style);
        initialize(label,false); 
    }
    

    public SOSMenuItem(Menu parent, int style, String menuName_, String label) {
        super(parent, style);
        this.menuName = menuName_;
        initialize(label,false); 
    }

    public SOSMenuItem(Menu parent, int style, String menuName_, String label, boolean checked) {
        super(parent, style);
        this.menuName = menuName_;
        initialize(label,checked); 
    }
    
   private void initialize(String label,boolean checked) {
       prefs = Preferences.userNodeForPackage(this.getClass());

       setText(label);
       setSelection(getSelectionFromPrefs(checked));
       

       addSelectionListener(new SelectionAdapter() {
           public void widgetSelected(SelectionEvent e) {
               prefs.node(SOS_SCHEDULER).put(prefKey(), getSelectionAsString());;
           }
       });
   
   }
   private String prefKey() {
       
       return "MENU_ITEM:"+ menuName + ":" +getText() + ":selection";
   }
    
   private boolean getSelectionFromPrefs(boolean defaultValue) {
       String defaultS = "false";
       if (defaultValue) {
           defaultS = "true";
       }
       String sel = prefs.node(SOS_SCHEDULER).get(prefKey(), defaultS);
       return sel.equals("true");        
   }
   
   public void setText(String menuName_, String text) {
       this.menuName = menuName_;
       super.setText(text);
   }
    
   private String getSelectionAsString() {
       if (getSelection()) {
           return "true";
       }else {
           return "false";
       }
   }
  
    
    protected void checkSubclass() {

        // Disable the check that prevents subclassing of SWT components
    }


}
