/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.eventing.frontend;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;

/**
 * <p>Title: </p>
 * <p>Description: simple client for the scheduler</p>
 * <p>Copyright: Copyright (c) 2008</p>
 * <p>Company: SOS GmbH</p>
 * @author <a href="mailto:ghassan.beydoun@sos-berlin.com">Ghassan Beydoun</a>
 * @version $Id$
 */
@Deprecated
public class SchedulerSocket extends Socket {

	private BufferedReader	in	= null;

	private PrintWriter		out	= null;

	private int				port;

	private String			host;

	private int				timeout;

	public SchedulerSocket() {
		super();
	}

	/*
	 * Constructor
	 */
	public SchedulerSocket(final String host, final int port, final int timeout) throws IOException {

		super(host, port);
		this.host = host;
		this.port = port;
		this.timeout = timeout;
	}

	public void connect(final String host, final int port, final int timeout) throws IOException {
		this.host = host;
		this.port = port;

		InetAddress addr = InetAddress.getByName(host);

		SocketAddress sockaddr = new InetSocketAddress(addr, port);

		super.connect(sockaddr, timeout);

	}

	/*
	 * Returns a stream of type PrintWriter
	 */
	public PrintWriter getPrintWriter() throws IOException {
		if (out == null) {
			out = new PrintWriter(super.getOutputStream(), true);
		}
		return out;

	}

	/*
	 * Returns a stream of type BufferedReader
	 */
	public BufferedReader getBufferedReader() throws IOException {
		if (in == null) {
			in = new BufferedReader(new InputStreamReader(super.getInputStream()));
		}
		return in;
	}

	/*
	 * Flush the SchedulerOutputStream before
	 * closing the socket.
	 */
	@Override
	public synchronized void close() throws IOException {
		if (getOutputStream() != null)
			getOutputStream().flush();
		super.close();

	}

	/**
	 * sends a query to the scheduler
	 *
	 * @param request
	 * @throws java.lang.Exception
	 */
	public void sendRequest(final String request) throws Exception {
		out = getPrintWriter();
		if (out != null) {
			if (request.indexOf("<?xml") == 0) {
				out.print(request + "\r\n");
			}
			else {
				out.print("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>" + request + "\r\n");
			}
			out.flush();
		}
	}

	/**
	 * returns the last response from the scheduler
	 *
	 * @return String the scheduler response, else empty string
	 * @throws IOException, RuntimeException
	 */
	public String getResponse() throws IOException, RuntimeException {
		int b;
		StringBuffer response = new StringBuffer();
		in = getBufferedReader();
		if (in != null) {
			while ((b = in.read()) != -1) {
				if (b == 0)
					break;
				response.append((char) b);

			} // while
		}

		return response.toString();
	}

	@Override
	public int getPort() {
		return port;
	}

	public void setPort(final int port) {
		this.port = port;
	}

	public String getHost() {
		return host;
	}

	public void setHost(final String host) {
		this.host = host;
	}

}
