/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.commands;

import java.math.BigInteger;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

import org.apache.log4j.Logger;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.answers.Calendar;

/**
* \class JSCmdShowCalendar 
* 
* \brief JSCmdShowCalendar - 
* 
* \details
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id: JSCmdShowCalendar.java 22519 2014-02-19 12:44:26Z sos $18.01.2011
* \see reference
*
* Created on 18.01.2011 18:28:20
 */

public class JSCmdShowCalendar extends ShowCalendar {

	private final String		conClassName	= "JSCmdShowCalendar";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSCmdShowCalendar.class);
	private DatatypeFactory objDatatypeFactory 	= null;

	public JSCmdShowCalendar(SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}

	public void setLimit(int i) {
		super.setLimit(BigInteger.valueOf(i));
	}

//	Doesn't work with IBM Java
//	
//	public void setFrom(String strDateAndTime) {
//		XMLGregorianCalendar objGC = XMLGregorianCalendarImpl.parse(strDateAndTime);
//		super.setFrom(objGC);
//	}
//	
//	public void setBefore(String strDateAndTime) {
//		XMLGregorianCalendar objGC = XMLGregorianCalendarImpl.parse(strDateAndTime);
//		super.setBefore(objGC);
//	}
	
	private DatatypeFactory datatypeFactoryInstance() {
		final String conMethodName = conClassName + "::datatypeFactoryInstance";
		if(objDatatypeFactory == null) {
			try {
				objDatatypeFactory = DatatypeFactory.newInstance();
			}
			catch (DatatypeConfigurationException e) {
				e.printStackTrace();
				throw new JobSchedulerException(String.format("%1$s: Can't get instantiate DatatypeFactory", conMethodName), e);
			}
		}
		return objDatatypeFactory;
	}
	
	public void setFrom(String strDateAndTime) {
		XMLGregorianCalendar objGC = datatypeFactoryInstance().newXMLGregorianCalendar(strDateAndTime);
		super.setFrom(objGC);
	}
	
	public void setBefore(String strDateAndTime) {
		XMLGregorianCalendar objGC = datatypeFactoryInstance().newXMLGregorianCalendar(strDateAndTime);
		super.setBefore(objGC);
	}
	
	public Calendar getCalendar() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getCalendar";
		Calendar objCalendar = null;
		objCalendar = this.getAnswer().getCalendar();
//		objCalendar.setParent(objFactory);
		return objCalendar;
	} // public Calendar getCalendar


}
