/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.tools.logback.db;

/**
* \class JobnetPlanDBItem 
* 
* \brief JobnetPlanDBItem - 
* 
* \details
*
* \section JobnetPlanDBItem.java_intro_sec Introduction
*
* \section JobnetPlanDBItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 23.09.2011
* \see reference
*
* Created on 23.09.2011 15:08:05
 */

import com.sos.hibernate.classes.DbItem;
import org.apache.log4j.Logger;
import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import javax.persistence.*;

@Entity
@Table(name="LOGGING_EVENT_EXCEPTION")
public class LoggingEventExceptionDBItem extends DbItem {

	private static Logger logger = Logger.getLogger(LoggingEventExceptionDBItem.class);

	 private LoggingEventDBItem loggingEventDBItem = null;
     private Long eventId;
     private Long i;
     private String traceLine;

     private LoggingEventExceptionPK primaryKey;


 	public LoggingEventExceptionDBItem() {
 	   super();
 	}

    @EmbeddedId
    public LoggingEventExceptionPK getPrimaryKey() {
        return primaryKey;
    }

    @EmbeddedId
    public void setPrimaryKey(LoggingEventExceptionPK primaryKey) {
        this.primaryKey = primaryKey;
    }

    @Column(name="EVENT_ID", insertable = false, updatable = false)
    public Long getEventId() {
		return eventId;
	}

    @Column(name="EVENT_ID", insertable = false, updatable = false)
	public void setEventId(Long eventId) {
		this.eventId = eventId;
	}

    @Column(name="I", insertable = false, updatable = false)
    public Long getI() {
		return i;
	}

    @Column(name="I", insertable = false, updatable = false)
	public void setI(Long i) {
		this.i = i;
	}

    @Column(name="TRACE_LINE")
    public String getTraceLine() {
		return traceLine;
	}

    @Column(name="TRACE_LINE")
	public void setTraceLine(String traceLine) {
		this.traceLine = traceLine;
	}

    @ManyToOne (optional=false)
    @NotFound( action = NotFoundAction.EXCEPTION )
    @Cascade(CascadeType.ALL)
    @JoinColumn (name="`EVENT_ID`", insertable = false, updatable = false)
    public LoggingEventDBItem getLoggingEventDBItem() {
        return loggingEventDBItem;
    }
    
    public void setLoggingEventDBItem(LoggingEventDBItem loggingEventDBItem)  {
       this.loggingEventDBItem = loggingEventDBItem;
    }
    
}
