/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.util;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

/**
* \class SOSExcelFileWriter 
* 
* \brief SOSExcelFileWriter - 
* 
* \details
*
* \section SOSExcelFileWriter.java_intro_sec Introduction
*
* \section SOSExcelFileWriter.java_samples Some Samples
*
* --------------------------------------------------
* </p>
* \author UR
* @version $Id$22.11.2013
* \see reference
*
* Created on 22.11.2013 16:10:28
 */

/**
 * @author UR
 *
 */


public class SOSExcelFileWriter {
    private  ArrayList<Object[]> data;
    private Object[] header;
    private String nameOfSheet="Sheet";
    


    public SOSExcelFileWriter() {
        super();
        data = new ArrayList<Object[]>();
    }

    public void addRow(Object[] row) {
        data.add(row);
    }
    
    public void addHeader(Object[] header) {
        this.header =  header;
    }

    public void createFile(String file) {
        createFile(new File(file));
    }
    
  private int addRow(int rownum,HSSFSheet sheet,Object[] objArr) {
      Row row = sheet.createRow(rownum++);

      int cellnum = 0;
      for (Object obj : objArr) {
          Cell cell = row.createCell(cellnum++);
          if(obj instanceof Date)
              cell.setCellValue((Date)obj);
          else if(obj instanceof Boolean)
              cell.setCellValue((Boolean)obj);
          else if(obj instanceof String)
              cell.setCellValue((String)obj);
          else if(obj instanceof Double)
              cell.setCellValue((Double)obj);
      }
      return rownum;
  }

    public void createFile(File file) {
        HSSFWorkbook workbook = new HSSFWorkbook();
        HSSFSheet sheet = workbook.createSheet(nameOfSheet);

        int rownum = 0;

        rownum = addRow(rownum,sheet,header);
        for (int i=0;i<data.size();i++) {
            rownum = addRow(rownum,sheet,data.get(i));
        }
         
        try {
            FileOutputStream out = new FileOutputStream(file);
            workbook.write(out);
            out.close();
              
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    

}
